/*********************************************************************************************/
/*                                                                                           */
/*********************************************************************************************/

#include "../snes9x.h"
#include "../memmap.h"
#include "../ppu.h"
#include "../display.h"
#include "../apu.h"
#include "../soundux.h"
#include "../snapshot.h"

extern "C" const char *S9xGetDirFilename (const char *d,const char *e)
{
    static char filename [_MAX_PATH + 1];
    char drive [_MAX_DRIVE + 1];
    char dir [_MAX_DIR + 1];
    char fname [_MAX_FNAME + 1];
    char ext [_MAX_EXT + 1];

    if (strlen (GUI.FreezeFileDir))
    {
        _splitpath (Memory.ROMFilename, drive, dir, fname, ext);
        strcpy (filename, GUI.FreezeFileDir);
        strcat (filename, "\\");
        strcat (filename, d);
        strcat (filename, "\\");
        strcat (filename, fname);
        strcat (filename, e);
    }

    return (filename);
}

void BIOS_SFMT_LOAD ()
{
 	char filename [_MAX_PATH + 1];
 	strcpy (filename, GUI.FreezeFileDir);
 	strcat (filename, "\\BIOS\\SFMTBIOS.BIN");

 	FILE *fbios;
 	if ((fbios = fopen (filename, "rb")))
 	{
 	 	fread (Memory.SFMTBIOS, 1, 0x40000, fbios);
 	 	fclose (fbios);
 	 	memmove (&Memory.ROM [0x200000], &Memory.ROM [0x100000], 0x100000);
 	 	memmove (&Memory.ROM [0x100000], &Memory.ROM [0], 0x100000);
 	 	memcpy (&Memory.ROM [0], &Memory.SFMTBIOS [0], 0x40000);
 	}
}

#ifdef UNCO_FULL_TEAM

void BIOS_BSXBIOS_LOAD ()
{
       char filename [_MAX_PATH + 1];
       strcpy (filename, GUI.FreezeFileDir);
	strcat (filename, "\\BIOS\\BSXBIOS.BIN");

	FILE *fbios;
       if ((fbios = fopen (filename, "rb")))
       {
	   fread (Memory.BSXBIOS, 1, 0x100000, fbios);
	   fclose (fbios);
       }

	memcpy (&Memory.ROM [0x100000], &Memory.ROM [0], 0x100000);
}

void BIOS_BSXPSRAM_LOAD ()
{
       char filename_psr [_MAX_PATH + 1];
       strcpy (filename_psr, S9xGetDirFilename("bsxpsrm",".psr"));

	FILE *fpsram;
       if ((fpsram = fopen (filename_psr, "rb")))
       {
	   fread (Memory.BSXPSRAM, 1, 0x80000, fpsram);
	   fclose (fpsram);
       }

	memcpy (&Memory.ROM [0x200000], &Memory.BSXPSRAM [0], 0x80000);
}

void BIOS_BSXFONT_SET ()
{
     if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
     {
	memcpy (&Memory.ROM [0x398000], &Memory.BSXBIOS [0x48000], 0x8000);
	memcpy (&Memory.ROM [0x3a8000], &Memory.BSXBIOS [0x50000], 0x8000);
	memcpy (&Memory.ROM [0x3b8000], &Memory.BSXBIOS [0x58000], 0x8000);
	memcpy (&Memory.ROM [0x3c8000], &Memory.BSXBIOS [0x60000], 0x8000);
	memcpy (&Memory.ROM [0x3d8000], &Memory.BSXBIOS [0x68000], 0x8000);
	memcpy (&Memory.ROM [0x3e8000], &Memory.BSXBIOS [0x70000], 0x8000);
	memcpy (&Memory.ROM [0x3f8000], &Memory.BSXBIOS [0x78000], 0x8000);
     }
     else if (Memory.LoROM && Memory.ROM [0x7fd4] == 0)
     {
	memcpy (&Memory.ROM [0x300000], &Memory.BSXBIOS [0x48000], 0x8000);
	memcpy (&Memory.ROM [0x308000], &Memory.BSXBIOS [0x50000], 0x8000);
	memcpy (&Memory.ROM [0x310000], &Memory.BSXBIOS [0x58000], 0x8000);
	memcpy (&Memory.ROM [0x318000], &Memory.BSXBIOS [0x60000], 0x8000);
	memcpy (&Memory.ROM [0x320000], &Memory.BSXBIOS [0x68000], 0x8000);
	memcpy (&Memory.ROM [0x328000], &Memory.BSXBIOS [0x70000], 0x8000);
	memcpy (&Memory.ROM [0x330000], &Memory.BSXBIOS [0x78000], 0x8000);
     }
}

#endif

