
static struct ini_ssetting {
LPCTSTR windows;
LPCTSTR graphics;
LPCTSTR sound;
LPCTSTR cpu;
LPCTSTR timer;
LPCTSTR ControllerOption;
LPCTSTR joypad[5];
LPCTSTR gui;
LPCTSTR screenshot;
LPCTSTR debug;
LPCTSTR option;
LPCTSTR bios;
} Inis = {
"windows",
"graphics",
"sound",
"cpu",
"timer",
"ControllerOption",
{"joypad1", "joypad2","joypad3", "joypad4", "joypad5"},
"gui",
"screenshot",
"debug",
"option",
"BIOS"
};

static LPCTSTR Key_button_str[] = {
"Enable", "Left", "Right", "Up", "Down", "StartButton", "SelectButton",
 "AButton", "BButton", "XButton", "YButton", "LButton", "RButton",
 "Left_Turbo", "Right_Turbo", "Up_Turbo", "Down_Turbo", "StartButton_Turbo", "SelectButton_Turbo",
 "AButton_Turbo", "BButton_Turbo", "XButton_Turbo", "YButton_Turbo", "LButton_Turbo", "RButton_Turbo"
};

static LPCTSTR Str0 = "0";
static LPCTSTR Str1 = "1";

static const char Config_data[] = {
#ifdef UNCO_FULL_TEAM
#ifdef UNCO_FULL_TEAM_2
"; uosnes Windows v1.37c config file.\n"
#else
"; uosnes Windows v1.37c config file.\n"
#endif
#else
"; uosnes Windows v1.37c config file.\n"
#endif
"\n"
"[windows]\n"
";  0 - IDLE_PRIORITY_CLASS             Specify this class for a process whose threads run only when\n"
";                                      the system is idle. The threads of the process are preempted\n"
";                                      by the threads of any process running in a higher priority\n"
";                                      class. An example is a screen saver. The idle-priority class is\n"
";                                      inherited by child processes.\n"
";\n"
";  1 - NORMAL_PRIORITY_CLASS(default)  Specify this class for a process with no special scheduling\n"
";                                      needs.\n"
";\n"
";  2 - HIGH_PRIORITY_CLASS             Specify this class for a process that performs time-critical\n"
";                                      tasks that must be executed immediately. The threads of the\n"
";                                      process preempt the threads of normal or idle priority class\n"
";                                      processes. An example is Windows Task List, which must\n"
";                                      respond quickly when called by the user, regardless of the\n"
";                                      load on the operating system. Use extreme care when using\n"
";                                      the high-priority class, because a high-priority class\n"
";                                      application can use nearly all available CPU time.\n"
";\n"
";  3 - REALTIME_PRIORITY_CLASS         Specify this class for a process that has the highest possible\n"
";                                      priority. The threads of the process preempt the threads of all\n"
";                                      other processes, including operating system processes\n"
";                                      performing important tasks. For example, a real-time process\n"
";                                      that executes for more than a very brief interval can cause disk\n"
";                                      caches not to flush or cause the mouse to be unresponsive.\n"
"PriorityClass=\n"
"\n"
";  0 - THREAD_PRIORITY_LOWEST          Indicates 2 points below normal priority for the\n"
";                                      priority class.\n"
";\n"
";  1 - THREAD_PRIORITY_BELOW_NORMAL    Indicates 1 point below normal priority for the\n"
";                                      priority class.\n"
";\n"
";  2 - THREAD_PRIORITY_NORMAL(default) Indicates normal priority for the priority class.\n"
";\n"
";  3 - THREAD_PRIORITY_ABOVE_NORMAL    Indicates 1 point above normal priority for the\n"
";                                      priority class.\n"
";\n"
";  4 - THREAD_PRIORITY_HIGHEST         Indicates 2 points above normal priority for the\n"
";                                      priority class.\n"
";\n"
";  5 - THREAD_PRIORITY_IDLE            Indicates a base priority level of 1 for\n"
";                                      IDLE_PRIORITY_CLASS,\n"
";                                      NORMAL_PRIORITY_CLASS, or\n"
";                                      HIGH_PRIORITY_CLASS processes, and a base\n"
";                                      priority level of 16 for\n"
";                                      REALTIME_PRIORITY_CLASS processes.\n"
";\n"
";  6 - THREAD_PRIORITY_TIME_CRITICAL   Indicates a base priority level of 15 for\n"
";                                      IDLE_PRIORITY_CLASS,\n"
";                                      NORMAL_PRIORITY_CLASS, or\n"
";                                      HIGH_PRIORITY_CLASS processes, and a base\n"
";                                      priority level of 31 for\n"
";                                      REALTIME_PRIORITY_CLASS processes.\n"
"ThreadPriority=\n"
"\n"
"[graphics]\n"
";  Windowed or Fullscreen.\n"
";  0 - Window mode(default)\n"
";  1 - Fullscreen mode\n"
"Fullscreen=\n"
"\n"
";  DoubleRendering (default: Normal)\n"
";  Enable Double(x2) Rendering Mode, Hi-Res mode need this setting enable.\n"
";  0 - Normal\n"
";  1 - Double\n"
"DoubleRendering=\n"
"\n"
";  FullscreenDisplayModeIndex\n"
";  0 -   256x224, 8bit\n"
";  1 -   256x224,16bit\n"
";  2 -   256x240, 8bit\n"
";  3 -   256x240,16bit\n"
";  4 -   320x240, 8bit\n"
";  5 -   320x240,16bit\n"
";  6 -   400x300, 8bit\n"
";  7 -   400x300,16bit\n"
";  8 -   512x384, 8bit\n"
";  9 -   512x384,16bit\n"
"; 10 -   640x400, 8bit\n"
"; 11 -   640x400,16bit\n"
"; 12 -   512x448, 8bit\n"
"; 13 -   512x448,16bit\n"
"; 14 -   512x478, 8bit\n"
"; 15 -   512x478,16bit\n"
"; 16 -   640x480, 8bit\n"
"; 17 -   640x480,16bit\n"
"; 18 -   800x600, 8bit\n"
"; 19 -   800x600,16bit\n"
"; 20 -  1024x768, 8bit\n"
"; 21 -  1024x768,16bit\n"
"; 22 -  1152x864, 8bit\n"
"; 23 -  1152x864,16bit\n"
"; 24 - 1280x1024, 8bit\n"
"; 25 - 1280x1024,16bit\n"
"; 26 - 1600x1200, 8bit\n"
"; 27 - 1600x1200,16bit\n"
";\n"
";  16bit Normal Index 0-27 (default: 5)\n"
"FullscreenDisplayModeIndexNormal16=\n"
";\n"
";  16bit Double Index 12-27 (default: 17)\n"
"FullscreenDisplayModeIndexDouble16=\n"
";\n"
";  16bit Double Stretch Index 12-27 (default: 21)\n"
"FullscreenDisplayModeIndexDouble16_Stretch=\n"
";\n"
";   8bit Normal Index 0-27 (default: 4)\n"
"FullscreenDisplayModeIndexNormal8=\n"
";\n"
";   8bit Double Index 12-27 (default: 16)\n"
"FullscreenDisplayModeIndexDouble8=\n"
"\n"
";  DoubleRenderingModes16\n"
";  Selection Double Rendering Modes to SixteenBit.\n"
";   1 - HardwareX2\n"
";   2 - SoftwareX2(default)\n"
";   3 - Fake TV\n"
";   4 - SuperEagle\n"
";   5 - 2xSaI\n"
";   6 - Super2xSaI\n"
";   7 - Scale2xSaI\n"
";   8 - TV Mode\n"
";   9 - hq2x\n"
";  10 - lq2x\n"
"DoubleRenderingModes16=\n"
"\n"
";  DoubleRenderingModes8\n"
";  Double Rendering Modes to 8bit.\n"
";  1 - HardwareX2\n"
";  2 - SoftwareX2(default)\n"
";  3 - Fake TV\n"
"DoubleRenderingModes8=\n"
"\n"
";  Enable direct Rendering to screen VRAM,\n"
";  do speed up(raise frame rate) in several rendering mode.\n"
";  0 - Disable\n"
";  1 - Enable\n"
"DirectScreenRendering=\n"
"\n"
";  DisableHardwareScale\n"
";  0 - off(default)\n"
";  1 - on\n"
"DisableHardwareScale=\n"
"\n"
";  DoubleBuffering\n"
";  Use DoubleBuffering on Fullscreen Mode(default: off)\n"
";  0 - off\n"
";  1 - on\n"
"DoubleBuffering=\n"
"\n"
";  Windowed DirectDraw Clipper\n"
";  Force Windowed DirectDraw Clipper or auto switch\n"
";  Forced setting always do exactly DirectDraw cliping in window mode, but slowdown.\n"
";  0 - Auto switch(default)\n"
";  1 - Force\n"
"ForceWindowedDirectDrawClipper=\n"
"\n"
";  OffScreenVRAM\n"
";  This setting reserve offscreen buffer in VRAM area,\n"
";  to Speed Up or Slow Down ???\n"
";  default setting reserve system memory.\n"
";  0 - off(default)\n"
";  1 - on\n"
"OffScreenVRAM=\n"
"\n"
";  BackBufferVRAM\n"
";  0 - off(default)\n"
";  1 - on\n"
"BackBufferVRAM=\n"
"\n"
";  Use customized GFX engine.\n"
";  0 - Disable\n"
";  1 - Enable(default)\n"
"GFXengine2=\n"
"\n"
";  Render SixteenBit (default: on)\n"
";  0 - off\n"
";  1 - on\n"
"RenderSixteenBit=\n"
"\n"
";  Transparency (default: on)\n"
";  0 - off\n"
";  1 - on\n"
"Transparency=\n"
"\n"
";  Swap background layer priorities from background involved in sub-screen\n"
";  addition/subtraction. (default: disabled)\n"
";  0 - Disable\n"
";  1 - Enable\n"
"BGLayering=\n"
"\n"
";  Disable graphics windows emulation. (default: disable)\n"
";  0 - Disable (Enable Graphics Windows Emulation)\n"
";  1 - Enable\n"
"DisableGraphicWindows=\n"
"\n"
";  Turn off the H-DMA emulation. Pressing '0' during a game toggles H-DMA on\n"
";  and off. (default: enabled)\n"
";  0 - Enable\n"
";  1 - Disable\n"
"DisableHDMA=\n"
"\n"
";  Enables Vsync to smoothen animation. (slows down emulation though)\n"
";  (default: off)\n"
";  0 - off\n"
";  1 - on\n"
"wait_for_vsync=\n"
"\n"
";  Stretch the SNES display to fit the whole computer display.\n"
";  (default: off)\n"
";  0 - off\n"
";  1 - on\n"
"stretch=\n"
"\n"
";  Enables Hi-Res mode. Makes HiRes SNES games look correct\n"
";  (default: on)\n"
";  0 - off\n"
";  1 - on\n"
"hires=\n"
"\n"
";  Enables the mode 7 bi-linear filter code.\n"
";  (default: off)\n"
";  0 - off\n"
";  1 - on\n"
"Mode7Interpolate=\n"
"\n"
"[sound]\n"
";  Sound Output (default: on)\n"
";  0 - off\n"
";  1 - on\n"
"APUEnabled=\n"
"\n"
";  Sound Mode Index\n"
";  0 -  8000Hz,   mono,  8bit\n"
";  1 - 11025Hz,   mono,  8bit\n"
";  2 - 22050Hz,   mono,  8bit\n"
";  3 - 32000Hz,   mono,  8bit\n"
";  4 - 44100Hz,   mono,  8bit\n"
";  5 - 48000Hz,   mono,  8bit\n"
";  6 -  8000Hz,   mono, 16bit\n"
";  7 - 11025Hz,   mono, 16bit\n"
";  8 - 22050Hz,   mono, 16bit\n"
";  9 - 32000Hz,   mono, 16bit\n"
"; 10 - 44100Hz,   mono, 16bit\n"
"; 11 - 48000Hz,   mono, 16bit\n"
"; 12 -  8000Hz, stereo,  8bit\n"
"; 13 - 11025Hz, stereo,  8bit\n"
"; 14 - 22050Hz, stereo,  8bit\n"
"; 15 - 32000Hz, stereo,  8bit\n"
"; 16 - 44100Hz, stereo,  8bit\n"
"; 17 - 48000Hz, stereo,  8bit\n"
"; 18 -  8000Hz, stereo, 16bit\n"
"; 19 - 11025Hz, stereo, 16bit\n"
"; 20 - 22050Hz, stereo, 16bit\n"
"; 21 - 32000Hz, stereo, 16bit(default)\n"
"; 22 - 44100Hz, stereo, 16bit\n"
"; 23 - 48000Hz, stereo, 16bit\n"
"SoundMode=\n"
"\n"
";  InterpolatedSound 'smoothens' sound and has a low pass filter [bass] effect \n"
"InterpolatedSound=\n"
"\n"
";  Sound playback buffer length 1-7(1 << (SoundBufferLength - 1))*10ms. (default: 3)\n"
"SoundBufferLength=\n"
"\n"
";  SoundMixInterval 1-15(*10)ms. (default: 1)\n"
"SoundMixInterval=\n"
"\n"
";  Enable volume envelope height reading by the sound CPU. (default: enabled)\n"
"SoundEnvelopeHeightReading=\n"
"\n"
";  Disable emulation of the sound DSP master volume control.\n"
";  (default: disable)\n"
";  0 - Disable (Enable DSP master volume control)\n"
";  1 - Enable\n"
"DisableMasterVolume=\n"
"\n"
";  Volume level 1-5. (default: 1)\n"
"VolumeLevel=\n"
"\n"
";  Turn off a couple of speed hacks. The hacks boost the speed of many ROMs\n"
";  but cause problems in a few ROMs. (default: enabled)\n"
";  0 - Enable\n"
";  1 - Disable\n"
"Shutdown=\n"
"\n"
";  Sound Skip Waiting Method. (DO NOT use if sound output is enabled)\n"
";  (default: 0)\n"
";  valid values: 0 - 3 \n"
"SoundSkipMethod=\n"
"\n"
";  Turns on sound-sync code where sound data is generated in sync with the\n"
";  emulation of the SNES sound CPU instructions. Slighty slower emulation speed\n"
";  but helps reduce note and sound effects timing problems and one or two \n"
";  games actually require this mode, notably Williams Arcade Classics.\n"
";  (default: Enable)\n"
";  0 - Disable\n"
";  1 - Enable\n"
"SoundSync=\n"
"\n"
";  Reverse stereo sound output. (default: Disable)\n"
";  0 - Disable\n"
";  1 - Enable\n"
"ReverseStereo=\n"
"\n"
"[cpu]\n"
";  Percentage of CPU cycles to execute per scan line, decrease value to\n"
";  increase emulation frame rate. Most ROMs work with a value of 85 or above.\n"
";  1-199 (default: 100)\n"
"CyclesPercentage=\n"
"\n"
"[timer]\n"
";  Set this value to deliberately fix the frame skip rate and disable auto-\n"
";  speed regulation. (default: auto-adjust)\n"
";  valid values: 0 - 9\n"
";  Leave blank for auto-adjust\n"
"SkipFrames=\n"
"\n"
";  Max value of frame skip for auto-adjust.\n"
";  valid values: 0 - 10 (default: 10)\n"
"AutoMaxSkipFrames=\n"
"\n"
";  It skip this frame count in Turbo mode.\n"
";  valid values: (slow) 0 - 15 (fast) (default: 15)\n"
"TurboSkipFrames=\n"
"\n"
";  If auto-adjust frame skip option is in effect, then the emulator will\n"
";  try to maintain a constant game and music speed locked to this value by\n"
";  skipping the rendering of some frames or waiting until the required time\n"
";  is reached. Increase the value to slow down games, decrease it to speed\n"
";  up games.(Default: 16 for NTSC, 20 for PAL)\n"
"NTSCtiming=\n"
"PALtiming=\n"
"\n"
"[ControllerOption]\n"
";  Snes input device settings.\n"
";  1 - Exist\n"
";  0 - None\n"
";  (default: SnesMouse 1, SnesSuperScope 1, SnesMultiPlayer5 1,SnesJustifier 1)\n"
"SnesMouse=\n"
"SnesSuperScope=\n"
"SnesMultiPlayer5=\n"
"SnesJustifier=\n"
"\n"
";  Default pluged input device.\n"
";  0 - SnesMultiPlayer5\n"
";  1 - SnesJoypad (default)\n"
";  2 - SnesMouseSwapped\n"
";  3 - SnesMouse\n"
";  4 - SnesSuperScope\n"
";  5 - SnesJustifier\n"
"DefaultPlugedInputDevice=\n"
"\n"
";  Scanning rate for input device status\n"
";  valid values 1 / ? : (high)1, 2, 4, 8(low)\n"
";  low value raise frame rate, but do difficult to control\n"
";  Original Snes9x's default is 1\n"
"JoyReadRate=\n"
"\n"
";  Set DirectInput or WinAPI.\n"
";  0 - WinAPI (default)\n"
";  1 - DirectInput\n"
"DirectInput=\n"
"\n"
";  Don't edit.\n"
"JoyKeyMappedFunctionCode0=\n"
"JoyKeyMappedFunctionCode1=\n"
"JoyKeyMappedFunctionCode2=\n"
"JoyKeyMappedFunctionCode3=\n"
"JoyKeyMappedFunctionCode4=\n"
"JoyKeyMappedFunctionCode5=\n"
"JoyKeyMappedFunctionCode6=\n"
"JoyKeyMappedFunctionCode7=\n"
"\n"
";  Don't edit this section.\n"
"[joypad1]\n"
"Enable=\n"
"Right=\n"
"Left=\n"
"Down=\n"
"Up=\n"
"StartButton=\n"
"SelectButton=\n"
"LButton=\n"
"RButton=\n"
"XButton=\n"
"YButton=\n"
"AButton=\n"
"BButton=\n"
"Right_Turbo=\n"
"Left_Turbo=\n"
"Down_Turbo=\n"
"Up_Turbo=\n"
"StartButton_Turbo=\n"
"SelectButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"\n"
";  Don't edit this section.\n"
"[joypad2]\n"
"Enable=\n"
"Right=\n"
"Left=\n"
"Down=\n"
"Up=\n"
"StartButton=\n"
"SelectButton=\n"
"LButton=\n"
"RButton=\n"
"XButton=\n"
"YButton=\n"
"AButton=\n"
"BButton=\n"
"Right_Turbo=\n"
"Left_Turbo=\n"
"Down_Turbo=\n"
"Up_Turbo=\n"
"StartButton_Turbo=\n"
"SelectButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"\n"
";  Don't edit this section.\n"
"[joypad3]\n"
"Enable=\n"
"Right=\n"
"Left=\n"
"Down=\n"
"Up=\n"
"StartButton=\n"
"SelectButton=\n"
"LButton=\n"
"RButton=\n"
"XButton=\n"
"YButton=\n"
"AButton=\n"
"BButton=\n"
"Right_Turbo=\n"
"Left_Turbo=\n"
"Down_Turbo=\n"
"Up_Turbo=\n"
"StartButton_Turbo=\n"
"SelectButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"\n"
";  Don't edit this section.\n"
"[joypad4]\n"
"Enable=\n"
"Right=\n"
"Left=\n"
"Down=\n"
"Up=\n"
"StartButton=\n"
"SelectButton=\n"
"LButton=\n"
"RButton=\n"
"XButton=\n"
"YButton=\n"
"AButton=\n"
"BButton=\n"
"Right_Turbo=\n"
"Left_Turbo=\n"
"Down_Turbo=\n"
"Up_Turbo=\n"
"StartButton_Turbo=\n"
"SelectButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"\n"
";  Don't edit this section.\n"
"[joypad5]\n"
"Enable=\n"
"Right=\n"
"Left=\n"
"Down=\n"
"Up=\n"
"StartButton=\n"
"SelectButton=\n"
"LButton=\n"
"RButton=\n"
"XButton=\n"
"YButton=\n"
"AButton=\n"
"BButton=\n"
"Right_Turbo=\n"
"Left_Turbo=\n"
"Down_Turbo=\n"
"Up_Turbo=\n"
"StartButton_Turbo=\n"
"SelectButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"\n"
"[gui]\n"
";Sets the search directory for ROM images.\n"
"LastROMFileName=\n"
"\n"
";Recent Games\n"
"RecentROMFileName1=\n"
"RecentROMFileName2=\n"
"RecentROMFileName3=\n"
"RecentROMFileName4=\n"
"RecentROMFileName5=\n"
"RecentROMFileName6=\n"
"RecentROMFileName7=\n"
"RecentROMFileName8=\n"
"RecentROMFileName9=\n"
"RecentROMFileNameA=\n"
"\n"
";  Directory to store SRAM State save files to.\n"
";  (ex. C:\\SNES9X\\SNESNAPS)\n"
"SnapShotDirectory=\n"
"\n"
";  Screen image file save directory.\n"
";  (ex. C:\\SNES9X\\SCREEN)\n"
"ScreenShotDirectory=\n"
"\n"
";  Dumped SPC file save directory.\n"
";  (ex. C:\\SNES9X\\SPC)\n"
"SPCDumpDirectory=\n"
"\n"
";  Language US or JP, this setting is switchable in JP environment.\n"
";  0 - US\n"
";  1 - JP\n"
"Language=\n"
"\n"
";  File Browse Window.\n"
";  0 - GetOpenFileName()\n"
";  1 - uosXplorer\n"
"FileBrowseWindow=\n"
"\n"
";Don't edit.\n"
"WindowRectLeft=\n"
"WindowRectRight=\n"
"WindowRectTop=\n"
"WindowRectBottom=\n"
"uosXpWindowRectLeft=\n"
"uosXpWindowRectRight=\n"
"uosXpWindowRectTop=\n"
"uosXpWindowRectBottom=\n"
"uosXpMaximize=\n"
"uosXpVSplitBarPos0=\n"
"uosXpColumnWidth0=\n"
"uosXpColumnWidth1=\n"
"uosXpColumnWidth2=\n"
"uosXpColumnWidth3=\n"
"\n"
"[screenshot]\n"
";  SaveImagefileFormat\n"
";  0 - bmp (default)\n"
";  1 - pcx\n"
";  2 - gif\n"
";  3 - png\n"
"SaveImagefileFormat=\n"
"\n"
";  Reduce the color of image file to 256.\n"
"ReduceTheColorTo256=\n"
"\n"
";  Reduce the color of image file to 256(8bit), if it's within 256.\n"
"ReduceTheColorTo256IfWithin=\n"
"\n"
"ImagefileHiresStretch=\n"
"\n"
"RLEcompression256bitmap=\n"
"\n"
"[debug]\n"
"DisplayScreenBufferAll=\n"
"\n"
"[option]\n"
";  Enable cheat code\n"
";  It load cheat data \"*.CHT\" file from SnapShotDirectory.\n"
";  0 - Disable\n"
";  1 - Enable\n"
"ApplyCheats=\n"
"\n"
"ShowFPS=\n"
"\n"
"MuteSound=\n"
"\n"
"NormalSnap=\n"
"\n"
"SDD1Pack=\n"
"\n"
"DisableIRQCycleCount=\n"
"\n"
"AutoSaveDelay=\n"
"\n"
";  Enable uosnes CD-DA\n"
";  0 - Disable\n"
";  1 - Enable\n"
"UseCDDA=\n"
"\n"
";  uosnes CD-Drive Select\n"
";  0 - A: / 1 - B: / 2 - C: / 3 - D: / 4 - E: / 5 - F: / 6 - G:\n"
";  7 - H: / ... / 25 - Z:\n"
"CDDrv=\n"
"\n"
";  Don't edit.\n"
"RevID=\n"
"\n"
};

