#include "snes9xw.h"
#include "directx.h"
#include "joywin.h"
#include "cfgdlg.h"

static LRESULT CALLBACK EditGetKeyProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT CALLBACK SubPropProc(HWND hWnd, UINT uMsg,WPARAM wParam, LPARAM lParam);
static WORD SetJoyButtonText(HWND hWnd, WORD &JoyButton, WORD &JoyButtonOld, bool DuplicateCheckFlag);
static void SetSubClass();
static void ReleaseSubClass(HWND hWnd);
static void JoyDlgCtlSet(HWND hWnd);
static struct SJoypad Joypadcpy[5];
static DWORD MapFunc_cpy[8];
static int ComboNo;
static bool TimerActiveFlag = 0;
static HBRUSH SelectedEditBkGreen = 0;
static HBRUSH SelectedEditBkOrange = 0;

static WNDPROC Edit_Left, Edit_Right, Edit_Up, Edit_Down, Edit_Start, Edit_Select,
	   Edit_A, Edit_B, Edit_X, Edit_Y, Edit_L, Edit_R,
	   Edit_MapFunc0, Edit_MapFunc1, Edit_MapFunc2, Edit_MapFunc3,
	   Edit_MapFunc4, Edit_MapFunc5, Edit_MapFunc6, Edit_MapFunc7;
static HWND hEdit_Left, hEdit_Right, hEdit_Up, hEdit_Down, hEdit_Start, hEdit_Select,
	   hEdit_A, hEdit_B, hEdit_X, hEdit_Y, hEdit_L, hEdit_R,
	   hEdit_MapFunc0, hEdit_MapFunc1, hEdit_MapFunc2, hEdit_MapFunc3,
	   hEdit_MapFunc4, hEdit_MapFunc5, hEdit_MapFunc6, hEdit_MapFunc7, hFocus;
extern HWND hProp;
extern WNDPROC PropProc;

static unsigned char DirectX_DIuse_cpy;

bool SetJoyButtonCode(HWND hFocus, WORD KeyCode);

static struct JJoypadButtonRef {
	WORD *Button[12];
	BOOL *Turbo[12];
} JoypadButtonRef[5];

void JoySettingsLoad()
{
	int i;
	for (i = 0; i < 5; i++ ) {
		//CfbNXANZXpɃ|C^
		JoypadButtonRef[i].Button[0] = &Joypadcpy[i].Left;
		JoypadButtonRef[i].Button[1] = &Joypadcpy[i].Right;
		JoypadButtonRef[i].Button[2] = &Joypadcpy[i].Up;
		JoypadButtonRef[i].Button[3] = &Joypadcpy[i].Down;
		JoypadButtonRef[i].Button[4] = &Joypadcpy[i].Start;
		JoypadButtonRef[i].Button[5] = &Joypadcpy[i].Select;
		JoypadButtonRef[i].Button[6] = &Joypadcpy[i].A;
		JoypadButtonRef[i].Button[7] = &Joypadcpy[i].B;
		JoypadButtonRef[i].Button[8] = &Joypadcpy[i].X;
		JoypadButtonRef[i].Button[9] = &Joypadcpy[i].Y;
		JoypadButtonRef[i].Button[10] = &Joypadcpy[i].L;
		JoypadButtonRef[i].Button[11] = &Joypadcpy[i].R;
		JoypadButtonRef[i].Turbo[0] = &Joypadcpy[i].Turbo_Left;
		JoypadButtonRef[i].Turbo[1] = &Joypadcpy[i].Turbo_Right;
		JoypadButtonRef[i].Turbo[2] = &Joypadcpy[i].Turbo_Up;
		JoypadButtonRef[i].Turbo[3] = &Joypadcpy[i].Turbo_Down;
		JoypadButtonRef[i].Turbo[4] = &Joypadcpy[i].Turbo_Start;
		JoypadButtonRef[i].Turbo[5] = &Joypadcpy[i].Turbo_Select;
		JoypadButtonRef[i].Turbo[6] = &Joypadcpy[i].Turbo_A;
		JoypadButtonRef[i].Turbo[7] = &Joypadcpy[i].Turbo_B;
		JoypadButtonRef[i].Turbo[8] = &Joypadcpy[i].Turbo_X;
		JoypadButtonRef[i].Turbo[9] = &Joypadcpy[i].Turbo_Y;
		JoypadButtonRef[i].Turbo[10] = &Joypadcpy[i].Turbo_L;
		JoypadButtonRef[i].Turbo[11] = &Joypadcpy[i].Turbo_R;
		Joypadcpy[i] = Joypad[i];
	}
	for (i = 0; i < 8; i++) {
		MapFunc_cpy[i] = MapFunc[i];
	}
	DirectX_DIuse_cpy = DirectX.DIuse;
}

static HWND hJoypadDlg;

void JoyDefaultSettingsLoad()
{
	DirectX_DIuse_cpy = DirectX_DIuse_def;
	SendMessage(GetDlgItem(hJoypadDlg, IDC_INPUTCOMBO), CB_SETCURSEL, (WPARAM)(DirectX_DIuse_cpy ? 1 : 0), 0);
}

void JoySettingsSave()
{
	int i;
	for (i = 0; i < 5; i++ )
		Joypad[i] = Joypadcpy[i];
	MakeTurboStatus();
	for (i = 0; i < 8; i++) {
		MapFunc[i] = MapFunc_cpy[i];
	}
	if(DirectX_DIuse_cpy != DirectX.DIuse) {
		DirectX.DIuse = DirectX_DIuse_cpy;
		S9xwJoystickInit();
	}
}

//Joypad Configurasion
LRESULT CALLBACK JoypadDlgProc(HWND hWnd, UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	static char *combostr[] = {"Joypad #1", "Joypad #2", "Joypad #3", "Joypad #4", "Joypad #5"};
	static char *combostrDIorWinAPI[] = {"WindowsAPI", "DirectInput"};
	static char *combostrMapFunc_JP[] = {"Xbg 1 Z[u",
										"Xbg 2 Z[u",
										"Xbg 3 Z[u",
										"Xbg 4 Z[u",
										"Xbg 5 Z[u",
										"Xbg 1 [h",
										"Xbg 2 [h",
										"Xbg 3 [h",
										"Xbg 4 [h",
										"Xbg 5 [h",
										"^[{[h",
										"^[{ || >>",
										"Zbg",
										"\x83\x5ctgZbg",
										"SPCzo",
										"XN[Vbg",
										"Xpp Key 1", // Original 
										"Xpp Key 2",
										"Xpp Key 3",
										"Xpp Key 4",
										"Xpp Key 5",
										"Xpp Key 6",
										"Xpp Key 7",
										"Xpp Key 8",
										"Xpp Key 9",
										"Sscope Turbo",
										"Sscope Pause"};
										//"XN[Vbg"};
	static char *combostrMapFunc_US[] = {"Slot 1 save",
										"Slot 2 save",
										"Slot 3 save",
										"Slot 4 save",
										"Slot 5 save",
										"Slot 1 load",
										"Slot 2 load",
										"Slot 3 load",
										"Slot 4 load",
										"Slot 5 load",
										"Turbo Mode",
										"Turbo || >>",
										"Reset",
										"SoftReset",
										"SPC dump",
										"Screenshot",
										"Xpp Key 1", // Original 
										"Xpp Key 2",
										"Xpp Key 3",
										"Xpp Key 4",
										"Xpp Key 5",
										"Xpp Key 6",
										"Xpp Key 7",
										"Xpp Key 8",
										"Xpp Key 9",
										"Sscope Turbo",
										"Sscope Pause"};
										//"Screenshot"};
	static WORD jb;
	static int i2, i3, i4;
	volatile static unsigned char JoyStatusReadingFlag;
	switch (uMsg) {
		case WM_INITDIALOG:
			hJoypadDlg = hWnd;
			//GfBgEChEnhۑiŎg)
			hEdit_Left = GetDlgItem(hWnd, IDC_EDIT_LEFT);
			hEdit_Right = GetDlgItem(hWnd, IDC_EDIT_RIGHT);
			hEdit_Up = GetDlgItem(hWnd, IDC_EDIT_UP);
			hEdit_Down = GetDlgItem(hWnd, IDC_EDIT_DOWN);
			hEdit_Start = GetDlgItem(hWnd, IDC_EDIT_START);
			hEdit_Select = GetDlgItem(hWnd, IDC_EDIT_SELECT);
			hEdit_A = GetDlgItem(hWnd, IDC_EDIT_A);
			hEdit_B = GetDlgItem(hWnd, IDC_EDIT_B);
			hEdit_X = GetDlgItem(hWnd, IDC_EDIT_X);
			hEdit_Y = GetDlgItem(hWnd, IDC_EDIT_Y);
			hEdit_L = GetDlgItem(hWnd, IDC_EDIT_L);
			hEdit_R = GetDlgItem(hWnd, IDC_EDIT_R);
			hEdit_MapFunc0 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC0);
			hEdit_MapFunc1 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC1);
			hEdit_MapFunc2 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC2);
			hEdit_MapFunc3 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC3);
			hEdit_MapFunc4 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC4);
			hEdit_MapFunc5 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC5);
			hEdit_MapFunc6 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC6);
			hEdit_MapFunc7 = GetDlgItem(hWnd, IDC_EDIT_MAPFUNC7);

			for (i2 = 0; i2 < 5; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_CTRLCOMBO), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)combostr[i2]);
			}
			SendMessage(GetDlgItem(hWnd, IDC_CTRLCOMBO), CB_SETCURSEL, (WPARAM)ComboNo, 0);
			//_CAO{bNXRg[ɕ\
			JoyDlgCtlSet(hWnd);

			for (i2 = 0; i2 < 2; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_INPUTCOMBO), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)combostrDIorWinAPI[i2]);
			}
			SendMessage(GetDlgItem(hWnd, IDC_INPUTCOMBO), CB_SETCURSEL, (WPARAM)(DirectX_DIuse_cpy ? 1 : 0), 0);
			

// Original
			//WCXeBbN@\蓖ăR{{bNXɃeLXgZbg
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO0), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO0), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[0])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO1), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO1), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[1])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO2), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO2), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[2])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO3), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO3), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[3])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO4), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO4), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[4])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO5), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO5), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[5])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO6), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO6), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[6])), 0);
			for (i2 = 0; i2 < 27; i2++ ) {
				SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO7), CB_INSERTSTRING, (WPARAM)i2, (LPARAM)(GUI.Language ? combostrMapFunc_JP[i2] : combostrMapFunc_US[i2]));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MAPFUNCCOMBO7), CB_SETCURSEL, (WPARAM)(HIWORD(MapFunc_cpy[7])), 0);
			break;
// Original 
		case WM_CTLCOLORSTATIC:
			if((HWND)lParam == hEdit_Left || (HWND)lParam == hEdit_Right
				|| (HWND)lParam == hEdit_Up || (HWND)lParam == hEdit_Down
				|| (HWND)lParam == hEdit_Start || (HWND)lParam == hEdit_Select
				|| (HWND)lParam == hEdit_A || (HWND)lParam == hEdit_B
				|| (HWND)lParam == hEdit_X || (HWND)lParam == hEdit_Y
				|| (HWND)lParam == hEdit_L || (HWND)lParam == hEdit_R) {
					if(GetFocus() == (HWND)lParam) {
						SetBkMode((HDC)wParam, TRANSPARENT);
						if(SelectedEditBkGreen)
							return (long)SelectedEditBkGreen;
					}
					return (long)GetStockObject(WHITE_BRUSH);
			}
			else if((HWND)lParam == hEdit_MapFunc0 || (HWND)lParam == hEdit_MapFunc1
				|| (HWND)lParam == hEdit_MapFunc2 || (HWND)lParam == hEdit_MapFunc3
				|| (HWND)lParam == hEdit_MapFunc4 || (HWND)lParam == hEdit_MapFunc5
				|| (HWND)lParam == hEdit_MapFunc6 || (HWND)lParam == hEdit_MapFunc7) {
					if(GetFocus() == (HWND)lParam) {
						SetBkMode((HDC)wParam, TRANSPARENT);
						if(SelectedEditBkOrange)
							return (long)SelectedEditBkOrange;
					}
					return (long)GetStockObject(WHITE_BRUSH);
			}
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_EDIT_UP:
				case IDC_EDIT_DOWN:
				case IDC_EDIT_LEFT:
				case IDC_EDIT_RIGHT:
				case IDC_EDIT_A:
				case IDC_EDIT_B:
				case IDC_EDIT_X:
				case IDC_EDIT_Y:
				case IDC_EDIT_L:
				case IDC_EDIT_R:
				case IDC_EDIT_SELECT:
				case IDC_EDIT_START:
				case IDC_EDIT_MAPFUNC0:
				case IDC_EDIT_MAPFUNC1:
				case IDC_EDIT_MAPFUNC2:
				case IDC_EDIT_MAPFUNC3:
				case IDC_EDIT_MAPFUNC4:
				case IDC_EDIT_MAPFUNC5:
				case IDC_EDIT_MAPFUNC6:
				case IDC_EDIT_MAPFUNC7:
					if(HIWORD(wParam) == EN_KILLFOCUS)
						InvalidateRgn((HWND)lParam, NULL, TRUE);
					break;

				case IDC_CTRLCOMBO:
					if(HIWORD(wParam) == CBN_SELENDOK) {
						ComboNo = (int)SendMessage(GetDlgItem(hWnd, IDC_CTRLCOMBO), CB_GETCURSEL, 0, 0);
						JoyDlgCtlSet(hWnd);
					}
					break;

				case IDC_JOYENABLE_CHECK:
					if(HIWORD(wParam) == BN_CLICKED) {
						Joypadcpy[ComboNo].Enabled = IsDlgButtonChecked(hWnd, (int)LOWORD(wParam)) == BST_CHECKED;
						ConfigDlgSettingsChanged(hWnd);
					}
					break;

				case IDC_INPUTCOMBO:
					if(HIWORD(wParam) == CBN_SELENDOK) {
						if(SendMessage(GetDlgItem(hWnd, IDC_INPUTCOMBO), CB_GETCURSEL, 0, 0) == 1 &&
							!DirectX_DIuse_cpy) {
							DirectX_DIuse_cpy = TRUE;
							ConfigDlgSettingsChanged(hWnd);
						}
						else if(DirectX_DIuse_cpy) {
							DirectX_DIuse_cpy = FALSE;
							ConfigDlgSettingsChanged(hWnd);
						}
					}
					break;

				case IDC_MAPFUNCCOMBO0:
				case IDC_MAPFUNCCOMBO1:
				case IDC_MAPFUNCCOMBO2:
				case IDC_MAPFUNCCOMBO3:
				case IDC_MAPFUNCCOMBO4:
				case IDC_MAPFUNCCOMBO5:
				case IDC_MAPFUNCCOMBO6:
				case IDC_MAPFUNCCOMBO7:
					if(HIWORD(wParam) == CBN_SELENDOK) {
						if(LOWORD(wParam) == IDC_MAPFUNCCOMBO0)
							MapFunc_cpy[0] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[0]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO1)
							MapFunc_cpy[1] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[1]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO2)
							MapFunc_cpy[2] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[2]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO3)
							MapFunc_cpy[3] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[3]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO4)
							MapFunc_cpy[4] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[4]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO5)
							MapFunc_cpy[5] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[5]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO6)
							MapFunc_cpy[6] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[6]);
						else if(LOWORD(wParam) == IDC_MAPFUNCCOMBO7)
							MapFunc_cpy[7] = (SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0) << 16) + LOWORD(MapFunc_cpy[7]);
						if(MapFunc_cpy[0] != MapFunc[0] || MapFunc_cpy[1] != MapFunc[1] || MapFunc_cpy[2] != MapFunc[2] || MapFunc_cpy[3] != MapFunc[3]
						|| MapFunc_cpy[4] != MapFunc[4] || MapFunc_cpy[5] != MapFunc[5] || MapFunc_cpy[6] != MapFunc[6] || MapFunc_cpy[7] != MapFunc[7]) {
							ConfigDlgSettingsChanged(hWnd);
						}
					}
					break;

				//Turbo`FbN
				case IDC_CHECK_TURBO_LEFT:
				case IDC_CHECK_TURBO_RIGHT:
				case IDC_CHECK_TURBO_UP:
				case IDC_CHECK_TURBO_DOWN:
				case IDC_CHECK_TURBO_START:
				case IDC_CHECK_TURBO_SELECT:
				case IDC_CHECK_TURBO_A:
				case IDC_CHECK_TURBO_B:
				case IDC_CHECK_TURBO_X:
				case IDC_CHECK_TURBO_Y:
				case IDC_CHECK_TURBO_L:
				case IDC_CHECK_TURBO_R:
					if(HIWORD(wParam) == BN_CLICKED) {
						if(IDC_CHECK_TURBO_LEFT == LOWORD(wParam))
							i3 = 0;
						else if (IDC_CHECK_TURBO_RIGHT == LOWORD(wParam))
							i3 = 1;
						else if (IDC_CHECK_TURBO_UP == LOWORD(wParam))
							i3 = 2;
						else if (IDC_CHECK_TURBO_DOWN == LOWORD(wParam))
							i3 = 3;
						else if (IDC_CHECK_TURBO_START == LOWORD(wParam))
							i3 = 4;
						else if (IDC_CHECK_TURBO_SELECT == LOWORD(wParam))
							i3 = 5;
						else if (IDC_CHECK_TURBO_A == LOWORD(wParam))
							i3 = 6;
						else if (IDC_CHECK_TURBO_B == LOWORD(wParam))
							i3 = 7;
						else if (IDC_CHECK_TURBO_X == LOWORD(wParam))
							i3 = 8;
						else if (IDC_CHECK_TURBO_Y == LOWORD(wParam))
							i3 = 9;
						else if (IDC_CHECK_TURBO_L == LOWORD(wParam))
							i3 = 10;
						else if (IDC_CHECK_TURBO_R == LOWORD(wParam))
							i3 = 11;
						*JoypadButtonRef[ComboNo].Turbo[i3] = IsDlgButtonChecked(hWnd, (int)LOWORD(wParam)) == BST_CHECKED;
						ConfigDlgSettingsChanged(hWnd);
					}
					break;

				default:
					break;
			}
			break;

		case WM_NOTIFY:
			switch(((NMHDR *)lParam)->code) {
				case PSN_APPLY:
					ConfigDlgSettingsSave();
					break;

				case PSN_HELP:
					ConfigDlgDefaultSettingsLoad(hWnd);
					break;

				case PSN_QUERYCANCEL:
					ReleaseSubClass(hWnd);
					break;

				case PSN_SETACTIVE:
					StartPageIndex = 2;
					JoyStatusReadingFlag = 0;
					//GfBgEChEIԂŐFςuV쐬
					if(!SelectedEditBkGreen)
						SelectedEditBkGreen = CreateSolidBrush(RGB(0, 255, 0));
					if(!SelectedEditBkOrange)
						SelectedEditBkOrange = CreateSolidBrush(RGB(0xff, 0xa5, 0x00));
					//WCXeBbN̓`FbNp^C}Zbg
					if(!TimerActiveFlag && SetTimer(hWnd, 100, 50, NULL))
						TimerActiveFlag = 1;
					//EChẼTuNX
					SetSubClass();
					break;

				case PSN_KILLACTIVE:
					ReleaseSubClass(hWnd);
					break;

				default:
					break;
			}
			break;

		case WM_TIMER:
			if(JoyStatusReadingFlag)
				break;
			JoyStatusReadingFlag = 1;
			for(i4 = 0; i4 < 8; i4++) {
				jb = GetJoyButtonCode();
				if(jb)
					SetJoyButtonCode(GetFocus(), jb);
			}
			JoyStatusReadingFlag = 0;
			break;

		default:
			break;
	}
	return FALSE;
}

static WORD SetJoyButtonText(HWND hWnd, WORD &JoyButton, WORD &JoyButtonOld, bool DuplicateCheckFlag)
{
	static char JoyText[16];
	static char JoyText2[16];
	static char JoyText3[16];
	static char *Result;
	static int J;

	FillMemory((PVOID)JoyText, 16, 0);
	FillMemory((PVOID)JoyText2, 16, 0);
	FillMemory((PVOID)JoyText3, 16, 0);
	Result = NULL;
	J = 0;

	if(JoyButton == VK_DELETE) {
		JoyButton = 0;
		SetWindowText(hWnd, "None");
		return VK_DELETE;
	}

	// Check for windows keys
	if( JoyButton == VK_MENU || JoyButton == VK_CAPITAL || JoyButton == VK_LWIN ||
		JoyButton == VK_RWIN || JoyButton == VK_APPS)
	{
		return 0;
	}

	// Check for Snes9X keys
	if( (JoyButton >= VK_F1 && JoyButton <= VK_F9) || JoyButton == VK_F11 || JoyButton == VK_F12 || JoyButton == VK_ESCAPE || JoyButton == VK_CONTROL || JoyButton == VK_SHIFT || JoyButton == VK_TAB)
	{
		return 0;
	}

	if(DuplicateCheckFlag) {
		if( JoyButton == LOWORD(MapFunc_cpy[0])) {
			MapFunc_cpy[0] = (MapFunc_cpy[0] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc0, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc0, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[1])) {
			MapFunc_cpy[1] = (MapFunc_cpy[1] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc1, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc1, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[2])) {
			MapFunc_cpy[2] = (MapFunc_cpy[2] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc2, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc2, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[3])) {
			MapFunc_cpy[3] = (MapFunc_cpy[3] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc3, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc3, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[4])) {
			MapFunc_cpy[4] = (MapFunc_cpy[4] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc4, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc4, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[5])) {
			MapFunc_cpy[5] = (MapFunc_cpy[5] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc5, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc5, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[6])) {
			MapFunc_cpy[6] = (MapFunc_cpy[6] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc6, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc6, JoyText2);
			return JoyButton;
		}
		if( JoyButton == LOWORD(MapFunc_cpy[7])) {
			MapFunc_cpy[7] = (MapFunc_cpy[7] & 0xffff0000) | JoyButtonOld;
			GetWindowText(hWnd, JoyText2, 16);
			GetWindowText(hEdit_MapFunc7, JoyText3, 16);
			SetWindowText(hWnd, JoyText3);
			SetWindowText(hEdit_MapFunc7, JoyText2);
			return JoyButton;
		}
		for(J = 0; J < 5; J++)
		{
			if( JoyButton == Joypadcpy[J].Left) {
				Joypadcpy[J].Left = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Left, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Left, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Right) {
				Joypadcpy[J].Right = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Right, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Right, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Up) {
				Joypadcpy[J].Up = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Up, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Up, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Down) {
				Joypadcpy[J].Down = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Down, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Down, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Start) {
				Joypadcpy[J].Start = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Start, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Start, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Select) {
				Joypadcpy[J].Select = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Select, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Select, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].A) {
				Joypadcpy[J].A = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_A, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_A, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].B) {
				Joypadcpy[J].B = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_B, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_B, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].X) {
				Joypadcpy[J].X = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_X, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_X, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].Y) {
				Joypadcpy[J].Y = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_Y, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_Y, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].L) {
				Joypadcpy[J].L = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_L, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_L, JoyText2);
					return JoyButton;
				}
				break;
			}
			if( JoyButton == Joypadcpy[J].R) {
				Joypadcpy[J].R = JoyButtonOld;
				if(J == ComboNo) {
					GetWindowText(hWnd, JoyText2, 16);
					GetWindowText(hEdit_R, JoyText3, 16);
					SetWindowText(hWnd, JoyText3);
					SetWindowText(hEdit_R, JoyText2);
					return JoyButton;
				}
				break;
			}
		}
	}

	if(JoyButton&0x8000)
	{
		JoyText[0] = 'J';
		JoyText[1] = 0x30 + ((JoyButton >> 8) & 0x0f);
		if(JoyText[1] > 0x39)
			JoyText[1] += 7;
		switch(JoyButton&0xff)
		{
			case 0: JoyText[2] = 'L'; break;
			case 1: JoyText[2] = 'R'; break;
			case 2: JoyText[2] = 'U'; break;
			case 3: JoyText[2] = 'D'; break;
			case 4: JoyText[2] = 'P'; JoyText[3] = 'L'; break;
			case 5: JoyText[2] = 'P'; JoyText[3] = 'R'; break;
			case 6: JoyText[2] = 'P'; JoyText[3] = 'U'; break;
			case 7: JoyText[2] = 'P'; JoyText[3] = 'D'; break;
			case 41: JoyText[2] = 'Z'; JoyText[3] = 'U'; break;
			case 42: JoyText[2] = 'Z'; JoyText[3] = 'D'; break;
			case 43: JoyText[2] = 'R'; JoyText[3] = 'U'; break;
			case 44: JoyText[2] = 'R'; JoyText[3] = 'D'; break;
			case 45: JoyText[2] = 'U'; JoyText[3] = 'U'; break;
			case 46: JoyText[2] = 'U'; JoyText[3] = 'D'; break;
			case 47: JoyText[2] = 'V'; JoyText[3] = 'U'; break;
			case 48: JoyText[2] = 'V'; JoyText[3] = 'D'; break;

			default:
				if( (JoyButton&0xff) > 40)
				{
					itoa((JoyButton&0xff), &JoyText[2], 10);
					break;
				}
				JoyText[2] = 'B';
				itoa(((JoyButton&0xff)-8), &JoyText[3], 10);
				break;
		}
	}

	// 0~9, A~Z
	else if( (JoyButton >= '0' && JoyButton <= '9') || (JoyButton >= 'A' && JoyButton <= 'Z'))
	{
		JoyText[0] = (char)JoyButton;
	}

	else if( JoyButton >= VK_NUMPAD0 && JoyButton <= VK_NUMPAD9)
	{
		JoyText[0] = 'N';
		JoyText[1] = '-';
		JoyText[2] = char('0'+(JoyButton - VK_NUMPAD0));
	}
	else {
		switch(JoyButton)
		{
			case 0: Result = "None"; break;
			case VK_TAB: Result = "Tab"; break;
			case VK_BACK: Result = "Bs"; break;
			case VK_CLEAR: Result = "Delete"; break;
			case VK_RETURN: Result = "Enter"; break;
			case VK_SHIFT:  Result = "Shift"; break;
			case VK_CONTROL: Result = "CTRL"; break;
			case VK_MENU: Result = "Alt"; break;
			case VK_PAUSE: Result = "Pause"; break;
			case VK_CAPITAL: Result = "C-Lock"; break;
			case VK_ESCAPE: Result = "ESC"; break;
			case VK_SPACE: Result = "Space"; break;
			case VK_PRIOR: Result = "PgUp"; break;
			case VK_NEXT: Result = "PgDn"; break;
			case VK_HOME: Result = "Home"; break;
			case VK_END: Result = "End"; break;
			case VK_LEFT: Result = "Left"; break;
			case VK_RIGHT: Result = "Right"; break;
			case VK_UP: Result = "Up"; break;
			case VK_DOWN: Result = "Down"; break;
			case VK_SELECT: Result = "Select"; break;
			case VK_PRINT: Result = "Print"; break;
			case VK_EXECUTE: Result = "Exec"; break;
			case VK_SNAPSHOT: Result = "Snap"; break;
			case VK_INSERT: Result = "Insert"; break;
			case VK_DELETE: Result = "Delete"; break;
			case VK_HELP: Result = "Help"; break;
			case VK_LWIN: Result = "LWin"; break;
			case VK_RWIN: Result = "RWin"; break;
			case VK_APPS: Result = "AppKey"; break;
			case VK_MULTIPLY: Result = "*"; break;
			case VK_ADD: Result = "+"; break;
			case VK_SEPARATOR: Result = "\\"; break;
			case VK_SUBTRACT: Result = "-"; break;
			case VK_DECIMAL: Result = "."; break;
			case VK_DIVIDE: Result = "/"; break;
			case VK_NUMLOCK: Result = "N-Lock"; break;
			case VK_SCROLL: Result = "S-Lock"; break;
			case VK_F10: Result = "F10"; break;
			case VK_F11: Result = "F11"; break;
			case VK_F12: Result = "F12"; break;
		}
		if(Result)
			lstrcpy(JoyText, Result);
		else
			itoa((int)JoyButton, JoyText, 10);
	}
	SetWindowText(hWnd, JoyText);
	return JoyButton;
}

bool SetJoyButtonCode(HWND hFocus, WORD KeyCode)
{
	if(hEdit_Up == hFocus) {
		if(SetJoyButtonText(hEdit_Up, KeyCode, Joypadcpy[ComboNo].Up, TRUE)) {
			Joypadcpy[ComboNo].Up = KeyCode;
			SetFocus(hEdit_Down);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Down == hFocus) {
		if(SetJoyButtonText(hEdit_Down, KeyCode, Joypadcpy[ComboNo].Down, TRUE)) {
			Joypadcpy[ComboNo].Down = KeyCode;
			SetFocus(hEdit_Left);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Left == hFocus) {
		if(SetJoyButtonText(hEdit_Left, KeyCode, Joypadcpy[ComboNo].Left, TRUE)) {
			Joypadcpy[ComboNo].Left = KeyCode;
			SetFocus(hEdit_Right);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Right == hFocus) {
		if(SetJoyButtonText(hEdit_Right, KeyCode, Joypadcpy[ComboNo].Right, TRUE)) {
			Joypadcpy[ComboNo].Right = KeyCode;
			SetFocus(hEdit_A);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_A == hFocus) {
		if(SetJoyButtonText(hEdit_A, KeyCode, Joypadcpy[ComboNo].A, TRUE)) {
			Joypadcpy[ComboNo].A = KeyCode;
			SetFocus(hEdit_B);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_B == hFocus) {
		if(SetJoyButtonText(hEdit_B, KeyCode, Joypadcpy[ComboNo].B, TRUE)) {
			Joypadcpy[ComboNo].B = KeyCode;
			SetFocus(hEdit_X);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_X == hFocus) {
		if(SetJoyButtonText(hEdit_X, KeyCode, Joypadcpy[ComboNo].X, TRUE)) {
			Joypadcpy[ComboNo].X = KeyCode;
			SetFocus(hEdit_Y);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Y == hFocus) {
		if(SetJoyButtonText(hEdit_Y, KeyCode, Joypadcpy[ComboNo].Y, TRUE)) {
			Joypadcpy[ComboNo].Y = KeyCode;
			SetFocus(hEdit_Select);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Select == hFocus) {
		if(SetJoyButtonText(hEdit_Select, KeyCode, Joypadcpy[ComboNo].Select, TRUE)) {
			Joypadcpy[ComboNo].Select = KeyCode;
			SetFocus(hEdit_Start);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_Start == hFocus) {
		if(SetJoyButtonText(hEdit_Start, KeyCode, Joypadcpy[ComboNo].Start, TRUE)) {
			Joypadcpy[ComboNo].Start = KeyCode;
			SetFocus(hEdit_L);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_L == hFocus) {
		if(SetJoyButtonText(hEdit_L, KeyCode, Joypadcpy[ComboNo].L, TRUE)) {
			Joypadcpy[ComboNo].L = KeyCode;
			SetFocus(hEdit_R);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_R == hFocus) {
		if(SetJoyButtonText(hEdit_R, KeyCode, Joypadcpy[ComboNo].R, TRUE)) {
			Joypadcpy[ComboNo].R = KeyCode;
			SetFocus(GetDlgItem(hProp, ID_APPLY_NOW));
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc0 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc0, KeyCode, (WORD &)MapFunc_cpy[0], TRUE)) {
			MapFunc_cpy[0] = (MapFunc_cpy[0] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc1);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc1 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc1, KeyCode, (WORD &)MapFunc_cpy[1], TRUE)) {
			MapFunc_cpy[1] = (MapFunc_cpy[1] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc2);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc2 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc2, KeyCode, (WORD &)MapFunc_cpy[2], TRUE)) {
			MapFunc_cpy[2] = (MapFunc_cpy[2] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc3);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc3 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc3, KeyCode, (WORD &)MapFunc_cpy[3], TRUE)) {
			MapFunc_cpy[3] = (MapFunc_cpy[3] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc4);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc4 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc4, KeyCode, (WORD &)MapFunc_cpy[4], TRUE)) {
			MapFunc_cpy[4] = (MapFunc_cpy[4] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc5);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc5 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc5, KeyCode, (WORD &)MapFunc_cpy[5], TRUE)) {
			MapFunc_cpy[5] = (MapFunc_cpy[5] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc6);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc6 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc6, KeyCode, (WORD &)MapFunc_cpy[6], TRUE)) {
			MapFunc_cpy[6] = (MapFunc_cpy[6] & 0xffff0000) | KeyCode;
			SetFocus(hEdit_MapFunc7);
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	if(hEdit_MapFunc7 == hFocus) {
		if(SetJoyButtonText(hEdit_MapFunc7, KeyCode, (WORD &)MapFunc_cpy[7], TRUE)) {
			MapFunc_cpy[7] = (MapFunc_cpy[7] & 0xffff0000) | KeyCode;
			SetFocus(GetDlgItem(hProp, ID_APPLY_NOW));
			ConfigDlgSettingsChanged(GetParent(hFocus));
		}
		return TRUE;
	}
	return FALSE;
}

static LRESULT CALLBACK EditGetKeyProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	hFocus = GetFocus();
	switch (uMsg) {

		case WM_KEYDOWN:
			if(!SetJoyButtonCode(hFocus, LOWORD(wParam)))
				break;
			return 0;

		case WM_SYSKEYDOWN:
			if(!SetJoyButtonCode(hFocus, LOWORD(wParam)))
				break;
			return 0;

		default:
			break;

	}
	if(hWnd == hEdit_Left)
		return (CallWindowProc(Edit_Left, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Right)
		return (CallWindowProc(Edit_Right, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Up)
		return (CallWindowProc(Edit_Up, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Down)
		return (CallWindowProc(Edit_Down, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Start)
		return (CallWindowProc(Edit_Start, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Select)
		return (CallWindowProc(Edit_Select, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_A)
		return (CallWindowProc(Edit_A, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_B)
		return (CallWindowProc(Edit_B, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_X)
		return (CallWindowProc(Edit_X, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_Y)
		return (CallWindowProc(Edit_Y, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_L)
		return (CallWindowProc(Edit_L, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_R)
		return (CallWindowProc(Edit_R, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc0)
		return (CallWindowProc(Edit_MapFunc0, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc1)
		return (CallWindowProc(Edit_MapFunc1, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc2)
		return (CallWindowProc(Edit_MapFunc2, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc3)
		return (CallWindowProc(Edit_MapFunc3, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc4)
		return (CallWindowProc(Edit_MapFunc4, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc5)
		return (CallWindowProc(Edit_MapFunc5, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc6)
		return (CallWindowProc(Edit_MapFunc6, hWnd, uMsg, wParam, lParam));
	if(hWnd == hEdit_MapFunc7)
		return (CallWindowProc(Edit_MapFunc7, hWnd, uMsg, wParam, lParam));
	return 0;
}

static void JoyDlgCtlSet(HWND hWnd)
{
	//`FbNt
	SendMessage(GetDlgItem(hWnd, IDC_JOYENABLE_CHECK), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Enabled ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_LEFT), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Left ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_RIGHT), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Right ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_UP), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Up ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_DOWN), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Down ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_START), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Start ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_SELECT), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Select ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_A), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_A ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_B), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_B ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_X), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_X ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_Y), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_Y ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_L), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_L ? 1 : 0), 0);
	SendMessage(GetDlgItem(hWnd, IDC_CHECK_TURBO_R), BM_SETCHECK, (WPARAM)(Joypadcpy[ComboNo].Turbo_R ? 1 : 0), 0);

	//GfBbgEChEɃL[{^eLXg\
	SetJoyButtonText(hEdit_Left, Joypadcpy[ComboNo].Left, Joypadcpy[ComboNo].Left, FALSE);
	SetJoyButtonText(hEdit_Right, Joypadcpy[ComboNo].Right, Joypadcpy[ComboNo].Right, FALSE);
	SetJoyButtonText(hEdit_Up, Joypadcpy[ComboNo].Up, Joypadcpy[ComboNo].Up, FALSE);
	SetJoyButtonText(hEdit_Down, Joypadcpy[ComboNo].Down, Joypadcpy[ComboNo].Down, FALSE);
	SetJoyButtonText(hEdit_Start, Joypadcpy[ComboNo].Start, Joypadcpy[ComboNo].Start, FALSE);
	SetJoyButtonText(hEdit_Select, Joypadcpy[ComboNo].Select, Joypadcpy[ComboNo].Select, FALSE);
	SetJoyButtonText(hEdit_A, Joypadcpy[ComboNo].A, Joypadcpy[ComboNo].A, FALSE);
	SetJoyButtonText(hEdit_B, Joypadcpy[ComboNo].B, Joypadcpy[ComboNo].B, FALSE);
	SetJoyButtonText(hEdit_X, Joypadcpy[ComboNo].X, Joypadcpy[ComboNo].X, FALSE);
	SetJoyButtonText(hEdit_Y, Joypadcpy[ComboNo].Y, Joypadcpy[ComboNo].Y, FALSE);
	SetJoyButtonText(hEdit_L, Joypadcpy[ComboNo].L, Joypadcpy[ComboNo].L, FALSE);
	SetJoyButtonText(hEdit_R, Joypadcpy[ComboNo].R, Joypadcpy[ComboNo].R, FALSE);

	//@\蓖ăGfBbgEChEɃL[{^eLXg\
	SetJoyButtonText(hEdit_MapFunc0, (WORD &)MapFunc_cpy[0], (WORD &)MapFunc_cpy[0], FALSE);
	SetJoyButtonText(hEdit_MapFunc1, (WORD &)MapFunc_cpy[1], (WORD &)MapFunc_cpy[1], FALSE);
	SetJoyButtonText(hEdit_MapFunc2, (WORD &)MapFunc_cpy[2], (WORD &)MapFunc_cpy[2], FALSE);
	SetJoyButtonText(hEdit_MapFunc3, (WORD &)MapFunc_cpy[3], (WORD &)MapFunc_cpy[3], FALSE);
	SetJoyButtonText(hEdit_MapFunc4, (WORD &)MapFunc_cpy[4], (WORD &)MapFunc_cpy[4], FALSE);
	SetJoyButtonText(hEdit_MapFunc5, (WORD &)MapFunc_cpy[5], (WORD &)MapFunc_cpy[5], FALSE);
	SetJoyButtonText(hEdit_MapFunc6, (WORD &)MapFunc_cpy[6], (WORD &)MapFunc_cpy[6], FALSE);
	SetJoyButtonText(hEdit_MapFunc7, (WORD &)MapFunc_cpy[7], (WORD &)MapFunc_cpy[7], FALSE);
}

static void SetSubClass()
{
	Edit_Left = (WNDPROC)GetWindowLong(hEdit_Left, GWL_WNDPROC);
	SetWindowLong(hEdit_Left, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Right = (WNDPROC)GetWindowLong(hEdit_Right, GWL_WNDPROC);
	SetWindowLong(hEdit_Right, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Up = (WNDPROC)GetWindowLong(hEdit_Up, GWL_WNDPROC);
	SetWindowLong(hEdit_Up, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Down = (WNDPROC)GetWindowLong(hEdit_Down, GWL_WNDPROC);
	SetWindowLong(hEdit_Down, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Start = (WNDPROC)GetWindowLong(hEdit_Start, GWL_WNDPROC);
	SetWindowLong(hEdit_Start, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Select = (WNDPROC)GetWindowLong(hEdit_Select, GWL_WNDPROC);
	SetWindowLong(hEdit_Select, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_A = (WNDPROC)GetWindowLong(hEdit_A, GWL_WNDPROC);
	SetWindowLong(hEdit_A, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_B = (WNDPROC)GetWindowLong(hEdit_B, GWL_WNDPROC);
	SetWindowLong(hEdit_B, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_X = (WNDPROC)GetWindowLong(hEdit_X, GWL_WNDPROC);
	SetWindowLong(hEdit_X, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_Y = (WNDPROC)GetWindowLong(hEdit_Y, GWL_WNDPROC);
	SetWindowLong(hEdit_Y, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_L = (WNDPROC)GetWindowLong(hEdit_L, GWL_WNDPROC);
	SetWindowLong(hEdit_L, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_R = (WNDPROC)GetWindowLong(hEdit_R, GWL_WNDPROC);
	SetWindowLong(hEdit_R, GWL_WNDPROC, (LONG)EditGetKeyProc);

	Edit_MapFunc0 = (WNDPROC)GetWindowLong(hEdit_MapFunc0, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc0, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc1 = (WNDPROC)GetWindowLong(hEdit_MapFunc1, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc1, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc2 = (WNDPROC)GetWindowLong(hEdit_MapFunc2, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc2, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc3 = (WNDPROC)GetWindowLong(hEdit_MapFunc3, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc3, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc4 = (WNDPROC)GetWindowLong(hEdit_MapFunc4, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc4, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc5 = (WNDPROC)GetWindowLong(hEdit_MapFunc5, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc5, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc6 = (WNDPROC)GetWindowLong(hEdit_MapFunc6, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc6, GWL_WNDPROC, (LONG)EditGetKeyProc);
	Edit_MapFunc7 = (WNDPROC)GetWindowLong(hEdit_MapFunc7, GWL_WNDPROC);
	SetWindowLong(hEdit_MapFunc7, GWL_WNDPROC, (LONG)EditGetKeyProc);

	SetWindowLong(hProp, GWL_WNDPROC, (LONG)SubPropProc);
}

static void ReleaseSubClass(HWND hWnd)
{
	if(TimerActiveFlag) {
		KillTimer(hWnd, 100);
		TimerActiveFlag = 0;
	}
	if(SelectedEditBkGreen) {
		DeleteObject(SelectedEditBkGreen);
		SelectedEditBkGreen = 0;
	}
	if(SelectedEditBkOrange) {
		DeleteObject(SelectedEditBkOrange);
		SelectedEditBkOrange = 0;
	}
	SetWindowLong(hEdit_Left, GWL_WNDPROC, (LONG)Edit_Left);
	SetWindowLong(hEdit_Right, GWL_WNDPROC, (LONG)Edit_Right);
	SetWindowLong(hEdit_Up, GWL_WNDPROC, (LONG)Edit_Up);
	SetWindowLong(hEdit_Down, GWL_WNDPROC, (LONG)Edit_Down);
	SetWindowLong(hEdit_Start, GWL_WNDPROC, (LONG)Edit_Start);
	SetWindowLong(hEdit_Select, GWL_WNDPROC, (LONG)Edit_Select);
	SetWindowLong(hEdit_A, GWL_WNDPROC, (LONG)Edit_A);
	SetWindowLong(hEdit_B, GWL_WNDPROC, (LONG)Edit_B);
	SetWindowLong(hEdit_X, GWL_WNDPROC, (LONG)Edit_X);
	SetWindowLong(hEdit_Y, GWL_WNDPROC, (LONG)Edit_Y);
	SetWindowLong(hEdit_L, GWL_WNDPROC, (LONG)Edit_L);
	SetWindowLong(hEdit_R, GWL_WNDPROC, (LONG)Edit_R);

	SetWindowLong(hEdit_MapFunc0, GWL_WNDPROC, (LONG)Edit_MapFunc0);
	SetWindowLong(hEdit_MapFunc1, GWL_WNDPROC, (LONG)Edit_MapFunc1);
	SetWindowLong(hEdit_MapFunc2, GWL_WNDPROC, (LONG)Edit_MapFunc2);
	SetWindowLong(hEdit_MapFunc3, GWL_WNDPROC, (LONG)Edit_MapFunc3);
	SetWindowLong(hEdit_MapFunc4, GWL_WNDPROC, (LONG)Edit_MapFunc4);
	SetWindowLong(hEdit_MapFunc5, GWL_WNDPROC, (LONG)Edit_MapFunc5);
	SetWindowLong(hEdit_MapFunc6, GWL_WNDPROC, (LONG)Edit_MapFunc6);
	SetWindowLong(hEdit_MapFunc7, GWL_WNDPROC, (LONG)Edit_MapFunc7);

	SetWindowLong(hProp, GWL_WNDPROC, (LONG)PropProc);
}
